diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/pluggable.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/pluggable.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/pluggable.php	2012-10-29 12:35:30.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/pluggable.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 529,535 ****
  
  	// Allow a grace period for POST and AJAX requests
  	if ( defined('DOING_AJAX') || 'POST' == $_SERVER['REQUEST_METHOD'] )
! 		$expired += 3600;
  
  	// Quick check to see if an honest cookie has expired
  	if ( $expired < time() ) {
--- 529,535 ----
  
  	// Allow a grace period for POST and AJAX requests
  	if ( defined('DOING_AJAX') || 'POST' == $_SERVER['REQUEST_METHOD'] )
! 		$expired += HOUR_IN_SECONDS;
  
  	// Quick check to see if an honest cookie has expired
  	if ( $expired < time() ) {
***************
*** 694,717 ****
  function wp_clear_auth_cookie() {
  	do_action('clear_auth_cookie');
  
! 	setcookie(AUTH_COOKIE, ' ', time() - 31536000, ADMIN_COOKIE_PATH, COOKIE_DOMAIN);
! 	setcookie(SECURE_AUTH_COOKIE, ' ', time() - 31536000, ADMIN_COOKIE_PATH, COOKIE_DOMAIN);
! 	setcookie(AUTH_COOKIE, ' ', time() - 31536000, PLUGINS_COOKIE_PATH, COOKIE_DOMAIN);
! 	setcookie(SECURE_AUTH_COOKIE, ' ', time() - 31536000, PLUGINS_COOKIE_PATH, COOKIE_DOMAIN);
! 	setcookie(LOGGED_IN_COOKIE, ' ', time() - 31536000, COOKIEPATH, COOKIE_DOMAIN);
! 	setcookie(LOGGED_IN_COOKIE, ' ', time() - 31536000, SITECOOKIEPATH, COOKIE_DOMAIN);
  
  	// Old cookies
! 	setcookie(AUTH_COOKIE, ' ', time() - 31536000, COOKIEPATH, COOKIE_DOMAIN);
! 	setcookie(AUTH_COOKIE, ' ', time() - 31536000, SITECOOKIEPATH, COOKIE_DOMAIN);
! 	setcookie(SECURE_AUTH_COOKIE, ' ', time() - 31536000, COOKIEPATH, COOKIE_DOMAIN);
! 	setcookie(SECURE_AUTH_COOKIE, ' ', time() - 31536000, SITECOOKIEPATH, COOKIE_DOMAIN);
  
  	// Even older cookies
! 	setcookie(USER_COOKIE, ' ', time() - 31536000, COOKIEPATH, COOKIE_DOMAIN);
! 	setcookie(PASS_COOKIE, ' ', time() - 31536000, COOKIEPATH, COOKIE_DOMAIN);
! 	setcookie(USER_COOKIE, ' ', time() - 31536000, SITECOOKIEPATH, COOKIE_DOMAIN);
! 	setcookie(PASS_COOKIE, ' ', time() - 31536000, SITECOOKIEPATH, COOKIE_DOMAIN);
  }
  endif;
  
--- 694,717 ----
  function wp_clear_auth_cookie() {
  	do_action('clear_auth_cookie');
  
! 	setcookie( AUTH_COOKIE,        ' ', time() - YEAR_IN_SECONDS, ADMIN_COOKIE_PATH,   COOKIE_DOMAIN );
! 	setcookie( SECURE_AUTH_COOKIE, ' ', time() - YEAR_IN_SECONDS, ADMIN_COOKIE_PATH,   COOKIE_DOMAIN );
! 	setcookie( AUTH_COOKIE,        ' ', time() - YEAR_IN_SECONDS, PLUGINS_COOKIE_PATH, COOKIE_DOMAIN );
! 	setcookie( SECURE_AUTH_COOKIE, ' ', time() - YEAR_IN_SECONDS, PLUGINS_COOKIE_PATH, COOKIE_DOMAIN );
! 	setcookie( LOGGED_IN_COOKIE,   ' ', time() - YEAR_IN_SECONDS, COOKIEPATH,          COOKIE_DOMAIN );
! 	setcookie( LOGGED_IN_COOKIE,   ' ', time() - YEAR_IN_SECONDS, SITECOOKIEPATH,      COOKIE_DOMAIN );
  
  	// Old cookies
! 	setcookie( AUTH_COOKIE,        ' ', time() - YEAR_IN_SECONDS, COOKIEPATH,     COOKIE_DOMAIN );
! 	setcookie( AUTH_COOKIE,        ' ', time() - YEAR_IN_SECONDS, SITECOOKIEPATH, COOKIE_DOMAIN );
! 	setcookie( SECURE_AUTH_COOKIE, ' ', time() - YEAR_IN_SECONDS, COOKIEPATH,     COOKIE_DOMAIN );
! 	setcookie( SECURE_AUTH_COOKIE, ' ', time() - YEAR_IN_SECONDS, SITECOOKIEPATH, COOKIE_DOMAIN );
  
  	// Even older cookies
! 	setcookie( USER_COOKIE, ' ', time() - YEAR_IN_SECONDS, COOKIEPATH,     COOKIE_DOMAIN );
! 	setcookie( PASS_COOKIE, ' ', time() - YEAR_IN_SECONDS, COOKIEPATH,     COOKIE_DOMAIN );
! 	setcookie( USER_COOKIE, ' ', time() - YEAR_IN_SECONDS, SITECOOKIEPATH, COOKIE_DOMAIN );
! 	setcookie( PASS_COOKIE, ' ', time() - YEAR_IN_SECONDS, SITECOOKIEPATH, COOKIE_DOMAIN );
  }
  endif;
  
***************
*** 748,758 ****
  
  	// If https is required and request is http, redirect
  	if ( $secure && !is_ssl() && false !== strpos($_SERVER['REQUEST_URI'], 'wp-admin') ) {
! 		if ( 0 === strpos($_SERVER['REQUEST_URI'], 'http') ) {
! 			wp_redirect(preg_replace('|^http://|', 'https://', $_SERVER['REQUEST_URI']));
  			exit();
  		} else {
! 			wp_redirect('https://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']);
  			exit();
  		}
  	}
--- 748,758 ----
  
  	// If https is required and request is http, redirect
  	if ( $secure && !is_ssl() && false !== strpos($_SERVER['REQUEST_URI'], 'wp-admin') ) {
! 		if ( 0 === strpos( $_SERVER['REQUEST_URI'], 'http' ) ) {
! 			wp_redirect( set_url_scheme( $_SERVER['REQUEST_URI'], 'https' ) );
  			exit();
  		} else {
! 			wp_redirect( 'https://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'] );
  			exit();
  		}
  	}
***************
*** 767,777 ****
  
  		// If the user wants ssl but the session is not ssl, redirect.
  		if ( !$secure && get_user_option('use_ssl', $user_id) && false !== strpos($_SERVER['REQUEST_URI'], 'wp-admin') ) {
! 			if ( 0 === strpos($_SERVER['REQUEST_URI'], 'http') ) {
! 				wp_redirect(preg_replace('|^http://|', 'https://', $_SERVER['REQUEST_URI']));
  				exit();
  			} else {
! 				wp_redirect('https://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']);
  				exit();
  			}
  		}
--- 767,777 ----
  
  		// If the user wants ssl but the session is not ssl, redirect.
  		if ( !$secure && get_user_option('use_ssl', $user_id) && false !== strpos($_SERVER['REQUEST_URI'], 'wp-admin') ) {
! 			if ( 0 === strpos( $_SERVER['REQUEST_URI'], 'http' ) ) {
! 				wp_redirect( set_url_scheme( $_SERVER['REQUEST_URI'], 'https' ) );
  				exit();
  			} else {
! 				wp_redirect( 'https://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'] );
  				exit();
  			}
  		}
***************
*** 782,793 ****
  	// The cookie is no good so force login
  	nocache_headers();
  
! 	if ( is_ssl() )
! 		$proto = 'https://';
! 	else
! 		$proto = 'http://';
! 
! 	$redirect = ( strpos($_SERVER['REQUEST_URI'], '/options.php') && wp_get_referer() ) ? wp_get_referer() : $proto . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
  
  	$login_url = wp_login_url($redirect, true);
  
--- 782,788 ----
  	// The cookie is no good so force login
  	nocache_headers();
  
! 	$redirect = ( strpos( $_SERVER['REQUEST_URI'], '/options.php' ) && wp_get_referer() ) ? wp_get_referer() : set_url_scheme( 'http://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'] );
  
  	$login_url = wp_login_url($redirect, true);
  
***************
*** 1195,1201 ****
   * @param string $plaintext_pass Optional. The user's plaintext password
   */
  function wp_new_user_notification($user_id, $plaintext_pass = '') {
! 	$user = new WP_User($user_id);
  
  	$user_login = stripslashes($user->user_login);
  	$user_email = stripslashes($user->user_email);
--- 1190,1196 ----
   * @param string $plaintext_pass Optional. The user's plaintext password
   */
  function wp_new_user_notification($user_id, $plaintext_pass = '') {
! 	$user = get_userdata( $user_id );
  
  	$user_login = stripslashes($user->user_login);
  	$user_email = stripslashes($user->user_email);
***************
*** 1234,1240 ****
   * @return int
   */
  function wp_nonce_tick() {
! 	$nonce_life = apply_filters('nonce_life', 86400);
  
  	return ceil(time() / ( $nonce_life / 2 ));
  }
--- 1229,1235 ----
   * @return int
   */
  function wp_nonce_tick() {
! 	$nonce_life = apply_filters( 'nonce_life', DAY_IN_SECONDS );
  
  	return ceil(time() / ( $nonce_life / 2 ));
  }
***************
*** 1256,1261 ****
--- 1251,1258 ----
  function wp_verify_nonce($nonce, $action = -1) {
  	$user = wp_get_current_user();
  	$uid = (int) $user->ID;
+ 	if ( ! $uid )
+ 		$uid = apply_filters( 'nonce_user_logged_out', $uid, $action );
  
  	$i = wp_nonce_tick();
  
***************
*** 1282,1287 ****
--- 1279,1286 ----
  function wp_create_nonce($action = -1) {
  	$user = wp_get_current_user();
  	$uid = (int) $user->ID;
+ 	if ( ! $uid )
+ 		$uid = apply_filters( 'nonce_user_logged_out', $uid, $action );
  
  	$i = wp_nonce_tick();
  
***************
*** 1501,1513 ****
  endif;
  
  if ( !function_exists('wp_rand') ) :
!  /**
   * Generates a random number
   *
   * @since 2.6.2
   *
!  * @param int $min Lower limit for the generated number (optional, default is 0)
!  * @param int $max Upper limit for the generated number (optional, default is 4294967295)
   * @return int A random number between min and max
   */
  function wp_rand( $min = 0, $max = 0 ) {
--- 1500,1512 ----
  endif;
  
  if ( !function_exists('wp_rand') ) :
! /**
   * Generates a random number
   *
   * @since 2.6.2
   *
!  * @param int $min Lower limit for the generated number
!  * @param int $max Upper limit for the generated number
   * @return int A random number between min and max
   */
  function wp_rand( $min = 0, $max = 0 ) {
***************
*** 1536,1545 ****
  
  	$value = abs(hexdec($value));
  
  	// Reduce the value to be within the min - max range
- 	// 4294967295 = 0xffffffff = max random number
  	if ( $max != 0 )
! 		$value = $min + (($max - $min + 1) * ($value / (4294967295 + 1)));
  
  	return abs(intval($value));
  }
--- 1535,1546 ----
  
  	$value = abs(hexdec($value));
  
+ 	// Some misconfigured 32bit environments (Entropy PHP, for example) truncate integers larger than PHP_INT_MAX to PHP_INT_MAX rather than overflowing them to floats.
+ 	$max_random_number = 3000000000 === 2147483647 ? (float) "4294967295" : 4294967295; // 4294967295 = 0xffffffff
+ 
  	// Reduce the value to be within the min - max range
  	if ( $max != 0 )
! 		$value = $min + ( $max - $min + 1 ) * $value / ( $max_random_number + 1 );
  
  	return abs(intval($value));
  }
***************
*** 1577,1583 ****
   * @param int|string|object $id_or_email A user ID,  email address, or comment object
   * @param int $size Size of the avatar image
   * @param string $default URL to a default image to use if no avatar is available
!  * @param string $alt Alternate text to use in image tag. Defaults to blank
   * @return string <img> tag for the user's avatar
  */
  function get_avatar( $id_or_email, $size = '96', $default = '', $alt = false ) {
--- 1578,1584 ----
   * @param int|string|object $id_or_email A user ID,  email address, or comment object
   * @param int $size Size of the avatar image
   * @param string $default URL to a default image to use if no avatar is available
!  * @param string $alt Alternative text to use in image tag. Defaults to blank
   * @return string <img> tag for the user's avatar
  */
  function get_avatar( $id_or_email, $size = '96', $default = '', $alt = false ) {
***************
*** 1639,1645 ****
  	if ( 'mystery' == $default )
  		$default = "$host/avatar/ad516503a11cd5ca435acc9bb6523536?s={$size}"; // ad516503a11cd5ca435acc9bb6523536 == md5('unknown@gravatar.com')
  	elseif ( 'blank' == $default )
! 		$default = includes_url('images/blank.gif');
  	elseif ( !empty($email) && 'gravatar_default' == $default )
  		$default = '';
  	elseif ( 'gravatar_default' == $default )
--- 1640,1646 ----
  	if ( 'mystery' == $default )
  		$default = "$host/avatar/ad516503a11cd5ca435acc9bb6523536?s={$size}"; // ad516503a11cd5ca435acc9bb6523536 == md5('unknown@gravatar.com')
  	elseif ( 'blank' == $default )
! 		$default = $email ? 'blank' : includes_url( 'images/blank.gif' );
  	elseif ( !empty($email) && 'gravatar_default' == $default )
  		$default = '';
  	elseif ( 'gravatar_default' == $default )
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/plugin.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/plugin.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/plugin.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/plugin.php	2012-12-17 16:18:40.000000000 -0600
***************
*** 80,87 ****
   * @global array $wp_filter Stores all of the filters
   *
   * @param string $tag The name of the filter hook.
!  * @param callback $function_to_check optional. If specified, return the priority of that function on this hook or false if not attached.
!  * @return int|boolean Optionally returns the priority on that hook for the specified function.
   */
  function has_filter($tag, $function_to_check = false) {
  	global $wp_filter;
--- 80,90 ----
   * @global array $wp_filter Stores all of the filters
   *
   * @param string $tag The name of the filter hook.
!  * @param callback $function_to_check optional.
!  * @return mixed If $function_to_check is omitted, returns boolean for whether the hook has anything registered.
!  * 	When checking a specific function, the priority of that hook is returned, or false if the function is not attached.
!  * 	When using the $function_to_check argument, this function may return a non-boolean value that evaluates to false
!  * 	(e.g.) 0, so use the === operator for testing the return value.
   */
  function has_filter($tag, $function_to_check = false) {
  	global $wp_filter;
***************
*** 254,260 ****
   * @param int $accepted_args optional. The number of arguments the function accepts (default: 1).
   * @return boolean Whether the function existed before it was removed.
   */
! function remove_filter($tag, $function_to_remove, $priority = 10, $accepted_args = 1) {
  	$function_to_remove = _wp_filter_build_unique_id($tag, $function_to_remove, $priority);
  
  	$r = isset($GLOBALS['wp_filter'][$tag][$priority][$function_to_remove]);
--- 257,263 ----
   * @param int $accepted_args optional. The number of arguments the function accepts (default: 1).
   * @return boolean Whether the function existed before it was removed.
   */
! function remove_filter( $tag, $function_to_remove, $priority = 10 ) {
  	$function_to_remove = _wp_filter_build_unique_id($tag, $function_to_remove, $priority);
  
  	$r = isset($GLOBALS['wp_filter'][$tag][$priority][$function_to_remove]);
***************
*** 497,504 ****
   * @see has_filter() has_action() is an alias of has_filter().
   *
   * @param string $tag The name of the action hook.
!  * @param callback $function_to_check optional. If specified, return the priority of that function on this hook or false if not attached.
!  * @return int|boolean Optionally returns the priority on that hook for the specified function.
   */
  function has_action($tag, $function_to_check = false) {
  	return has_filter($tag, $function_to_check);
--- 500,510 ----
   * @see has_filter() has_action() is an alias of has_filter().
   *
   * @param string $tag The name of the action hook.
!  * @param callback $function_to_check optional.
!  * @return mixed If $function_to_check is omitted, returns boolean for whether the hook has anything registered.
!  * 	When checking a specific function, the priority of that hook is returned, or false if the function is not attached.
!  * 	When using the $function_to_check argument, this function may return a non-boolean value that evaluates to false
!  * 	(e.g.) 0, so use the === operator for testing the return value.
   */
  function has_action($tag, $function_to_check = false) {
  	return has_filter($tag, $function_to_check);
***************
*** 518,528 ****
   * @param string $tag The action hook to which the function to be removed is hooked.
   * @param callback $function_to_remove The name of the function which should be removed.
   * @param int $priority optional The priority of the function (default: 10).
-  * @param int $accepted_args optional. The number of arguments the function accepts (default: 1).
   * @return boolean Whether the function is removed.
   */
! function remove_action($tag, $function_to_remove, $priority = 10, $accepted_args = 1) {
! 	return remove_filter($tag, $function_to_remove, $priority, $accepted_args);
  }
  
  /**
--- 524,533 ----
   * @param string $tag The action hook to which the function to be removed is hooked.
   * @param callback $function_to_remove The name of the function which should be removed.
   * @param int $priority optional The priority of the function (default: 10).
   * @return boolean Whether the function is removed.
   */
! function remove_action( $tag, $function_to_remove, $priority = 10 ) {
! 	return remove_filter( $tag, $function_to_remove, $priority );
  }
  
  /**
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/pomo/entry.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/pomo/entry.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/pomo/entry.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/pomo/entry.php	2012-12-17 16:18:39.000000000 -0600
***************
*** 2,8 ****
  /**
   * Contains Translation_Entry class
   *
!  * @version $Id: entry.php 621 2011-06-13 12:21:50Z nbachiyski $
   * @package pomo
   * @subpackage entry
   */
--- 2,8 ----
  /**
   * Contains Translation_Entry class
   *
!  * @version $Id: entry.php 718 2012-10-31 00:32:02Z nbachiyski $
   * @package pomo
   * @subpackage entry
   */
***************
*** 65,78 ****
  		// prepend context and EOT, like in MO files
  		return is_null($this->context)? $this->singular : $this->context.chr(4).$this->singular;
  	}
! 	
  	function merge_with(&$other) {
  		$this->flags = array_unique( array_merge( $this->flags, $other->flags ) );
  		$this->references = array_unique( array_merge( $this->references, $other->references ) );
  		if ( $this->extracted_comments != $other->extracted_comments ) {
  			$this->extracted_comments .= $other->extracted_comments;
  		}
! 		
  	}
  }
  endif;
\ No newline at end of file
--- 65,78 ----
  		// prepend context and EOT, like in MO files
  		return is_null($this->context)? $this->singular : $this->context.chr(4).$this->singular;
  	}
! 
  	function merge_with(&$other) {
  		$this->flags = array_unique( array_merge( $this->flags, $other->flags ) );
  		$this->references = array_unique( array_merge( $this->references, $other->references ) );
  		if ( $this->extracted_comments != $other->extracted_comments ) {
  			$this->extracted_comments .= $other->extracted_comments;
  		}
! 
  	}
  }
  endif;
\ No newline at end of file
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/pomo/mo.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/pomo/mo.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/pomo/mo.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/pomo/mo.php	2012-12-17 16:18:39.000000000 -0600
***************
*** 2,8 ****
  /**
   * Class for working with MO files
   *
!  * @version $Id: mo.php 602 2011-01-30 12:43:29Z nbachiyski $
   * @package pomo
   * @subpackage mo
   */
--- 2,8 ----
  /**
   * Class for working with MO files
   *
!  * @version $Id: mo.php 718 2012-10-31 00:32:02Z nbachiyski $
   * @package pomo
   * @subpackage mo
   */
***************
*** 34,40 ****
  		fclose($fh);
  		return $res;
  	}
! 	
  	function export() {
  		$tmp_fh = fopen("php://temp", 'r+');
  		if ( !$tmp_fh ) return false;
--- 34,40 ----
  		fclose($fh);
  		return $res;
  	}
! 
  	function export() {
  		$tmp_fh = fopen("php://temp", 'r+');
  		if ( !$tmp_fh ) return false;
***************
*** 42,50 ****
  		rewind( $tmp_fh );
  		return stream_get_contents( $tmp_fh );
  	}
! 	
  	function export_to_file_handle($fh) {
! 		$entries = array_filter($this->entries, create_function('$e', 'return !empty($e->translations);'));
  		ksort($entries);
  		$magic = 0x950412de;
  		$revision = 0;
--- 42,62 ----
  		rewind( $tmp_fh );
  		return stream_get_contents( $tmp_fh );
  	}
! 
! 	function is_entry_good_for_export( $entry ) {
! 		if ( empty( $entry->translations ) ) {
! 			return false;
! 		}
! 
! 		if ( !array_filter( $entry->translations ) ) {
! 			return false;
! 		}
! 
! 		return true;
! 	}
! 
  	function export_to_file_handle($fh) {
! 		$entries = array_filter( $this->entries, array( $this, 'is_entry_good_for_export' ) );
  		ksort($entries);
  		$magic = 0x950412de;
  		$revision = 0;
***************
*** 57,63 ****
  		fwrite($fh, pack('V*', $magic, $revision, $total, $originals_lenghts_addr,
  			$translations_lenghts_addr, $size_of_hash, $hash_addr));
  		fseek($fh, $originals_lenghts_addr);
! 		
  		// headers' msgid is an empty string
  		fwrite($fh, pack('VV', 0, $current_addr));
  		$current_addr++;
--- 69,75 ----
  		fwrite($fh, pack('V*', $magic, $revision, $total, $originals_lenghts_addr,
  			$translations_lenghts_addr, $size_of_hash, $hash_addr));
  		fseek($fh, $originals_lenghts_addr);
! 
  		// headers' msgid is an empty string
  		fwrite($fh, pack('VV', 0, $current_addr));
  		$current_addr++;
***************
*** 69,92 ****
  			fwrite($fh, pack('VV', $length, $current_addr));
  			$current_addr += $length + 1; // account for the NULL byte after
  		}
! 		
  		$exported_headers = $this->export_headers();
  		fwrite($fh, pack('VV', strlen($exported_headers), $current_addr));
  		$current_addr += strlen($exported_headers) + 1;
  		$translations_table = $exported_headers . chr(0);
! 		
  		foreach($entries as $entry) {
  			$translations_table .= $this->export_translations($entry) . chr(0);
  			$length = strlen($this->export_translations($entry));
  			fwrite($fh, pack('VV', $length, $current_addr));
  			$current_addr += $length + 1;
  		}
! 		
  		fwrite($fh, $originals_table);
  		fwrite($fh, $translations_table);
  		return true;
  	}
! 	
  	function export_original($entry) {
  		//TODO: warnings for control characters
  		$exported = $entry->singular;
--- 81,104 ----
  			fwrite($fh, pack('VV', $length, $current_addr));
  			$current_addr += $length + 1; // account for the NULL byte after
  		}
! 
  		$exported_headers = $this->export_headers();
  		fwrite($fh, pack('VV', strlen($exported_headers), $current_addr));
  		$current_addr += strlen($exported_headers) + 1;
  		$translations_table = $exported_headers . chr(0);
! 
  		foreach($entries as $entry) {
  			$translations_table .= $this->export_translations($entry) . chr(0);
  			$length = strlen($this->export_translations($entry));
  			fwrite($fh, pack('VV', $length, $current_addr));
  			$current_addr += $length + 1;
  		}
! 
  		fwrite($fh, $originals_table);
  		fwrite($fh, $translations_table);
  		return true;
  	}
! 
  	function export_original($entry) {
  		//TODO: warnings for control characters
  		$exported = $entry->singular;
***************
*** 94,105 ****
  		if (!is_null($entry->context)) $exported = $entry->context . chr(4) . $exported;
  		return $exported;
  	}
! 	
  	function export_translations($entry) {
  		//TODO: warnings for control characters
  		return implode(chr(0), $entry->translations);
  	}
! 	
  	function export_headers() {
  		$exported = '';
  		foreach($this->headers as $header => $value) {
--- 106,117 ----
  		if (!is_null($entry->context)) $exported = $entry->context . chr(4) . $exported;
  		return $exported;
  	}
! 
  	function export_translations($entry) {
  		//TODO: warnings for control characters
  		return implode(chr(0), $entry->translations);
  	}
! 
  	function export_headers() {
  		$exported = '';
  		foreach($this->headers as $header => $value) {
***************
*** 195,202 ****
  			$translation = $reader->substr( $strings, $t['pos'], $t['length'] );
  
  			if ('' === $original) {
! 				$headers = $this->make_headers($translation);
! 				$this->set_headers($headers);
  			} else {
  				$entry = &$this->make_entry($original, $translation);
  				$this->entries[$entry->key()] = &$entry;
--- 207,213 ----
  			$translation = $reader->substr( $strings, $t['pos'], $t['length'] );
  
  			if ('' === $original) {
! 				$this->set_headers($this->make_headers($translation));
  			} else {
  				$entry = &$this->make_entry($original, $translation);
  				$this->entries[$entry->key()] = &$entry;
***************
*** 208,214 ****
  	/**
  	 * Build a Translation_Entry from original string and translation strings,
  	 * found in a MO file
! 	 * 
  	 * @static
  	 * @param string $original original string to translate from MO file. Might contain
  	 * 	0x04 as context separator or 0x00 as singular/plural separator
--- 219,225 ----
  	/**
  	 * Build a Translation_Entry from original string and translation strings,
  	 * found in a MO file
! 	 *
  	 * @static
  	 * @param string $original original string to translate from MO file. Might contain
  	 * 	0x04 as context separator or 0x00 as singular/plural separator
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/pomo/po.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/pomo/po.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/pomo/po.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/pomo/po.php	2012-12-17 16:18:39.000000000 -0600
***************
*** 2,8 ****
  /**
   * Class for working with PO files
   *
!  * @version $Id: po.php 589 2010-12-18 01:40:57Z nbachiyski $
   * @package pomo
   * @subpackage po
   */
--- 2,8 ----
  /**
   * Class for working with PO files
   *
!  * @version $Id: po.php 718 2012-10-31 00:32:02Z nbachiyski $
   * @package pomo
   * @subpackage po
   */
***************
*** 18,24 ****
   */
  if ( !class_exists( 'PO' ) ):
  class PO extends Gettext_Translations {
! 	
  	var $comments_before_headers = '';
  
  	/**
--- 18,24 ----
   */
  if ( !class_exists( 'PO' ) ):
  class PO extends Gettext_Translations {
! 
  	var $comments_before_headers = '';
  
  	/**
***************
*** 80,89 ****
  		if (false === $res) return false;
  		return fclose($fh);
  	}
! 	
  	/**
  	 * Text to include as a comment before the start of the PO contents
! 	 * 
  	 * Doesn't need to include # in the beginning of lines, these are added automatically
  	 */
  	function set_comment_before_headers( $text ) {
--- 80,89 ----
  		if (false === $res) return false;
  		return fclose($fh);
  	}
! 
  	/**
  	 * Text to include as a comment before the start of the PO contents
! 	 *
  	 * Doesn't need to include # in the beginning of lines, these are added automatically
  	 */
  	function set_comment_before_headers( $text ) {
***************
*** 120,129 ****
  		$po = str_replace("$newline$quote$quote", '', $po);
  		return $po;
  	}
! 	
  	/**
  	 * Gives back the original string from a PO-formatted string
! 	 * 
  	 * @static
  	 * @param string $string PO-formatted string
  	 * @return string enascaped string
--- 120,129 ----
  		$po = str_replace("$newline$quote$quote", '', $po);
  		return $po;
  	}
! 
  	/**
  	 * Gives back the original string from a PO-formatted string
! 	 *
  	 * @static
  	 * @param string $string PO-formatted string
  	 * @return string enascaped string
***************
*** 153,159 ****
  	}
  
  	/**
! 	 * Inserts $with in the beginning of every new line of $string and 
  	 * returns the modified string
  	 *
  	 * @static
--- 153,159 ----
  	}
  
  	/**
! 	 * Inserts $with in the beginning of every new line of $string and
  	 * returns the modified string
  	 *
  	 * @static
***************
*** 229,237 ****
  			}
  		}
  		PO::read_line($f, 'clear');
! 		return $res !== false;
  	}
! 	
  	function read_entry($f, $lineno = 0) {
  		$entry = new Translation_Entry();
  		// where were we in the last step
--- 229,243 ----
  			}
  		}
  		PO::read_line($f, 'clear');
! 		if ( false === $res ) {
! 			return false;
! 		}
! 		if ( ! $this->headers && ! $this->entries ) {
! 			return false;
! 		}
! 		return true;
  	}
! 
  	function read_entry($f, $lineno = 0) {
  		$entry = new Translation_Entry();
  		// where were we in the last step
***************
*** 336,342 ****
  		}
  		return array('entry' => $entry, 'lineno' => $lineno);
  	}
! 	
  	function read_line($f, $action = 'read') {
  		static $last_line = '';
  		static $use_last_line = false;
--- 342,348 ----
  		}
  		return array('entry' => $entry, 'lineno' => $lineno);
  	}
! 
  	function read_line($f, $action = 'read') {
  		static $last_line = '';
  		static $use_last_line = false;
***************
*** 349,359 ****
  			return true;
  		}
  		$line = $use_last_line? $last_line : fgets($f);
  		$last_line = $line;
  		$use_last_line = false;
  		return $line;
  	}
! 	
  	function add_comment_to_entry(&$entry, $po_comment_line) {
  		$first_two = substr($po_comment_line, 0, 2);
  		$comment = trim(substr($po_comment_line, 2));
--- 355,366 ----
  			return true;
  		}
  		$line = $use_last_line? $last_line : fgets($f);
+ 		$line = ( "\r\n" == substr( $line, -2 ) ) ? rtrim( $line, "\r\n" ) . "\n" : $line;
  		$last_line = $line;
  		$use_last_line = false;
  		return $line;
  	}
! 
  	function add_comment_to_entry(&$entry, $po_comment_line) {
  		$first_two = substr($po_comment_line, 0, 2);
  		$comment = trim(substr($po_comment_line, 2));
***************
*** 367,377 ****
  			$entry->translator_comments = trim($entry->translator_comments . "\n" . $comment);
  		}
  	}
! 	
  	function trim_quotes($s) {
  		if ( substr($s, 0, 1) == '"') $s = substr($s, 1);
  		if ( substr($s, -1, 1) == '"') $s = substr($s, 0, -1);
  		return $s;
  	}
  }
! endif;
\ No newline at end of file
--- 374,384 ----
  			$entry->translator_comments = trim($entry->translator_comments . "\n" . $comment);
  		}
  	}
! 
  	function trim_quotes($s) {
  		if ( substr($s, 0, 1) == '"') $s = substr($s, 1);
  		if ( substr($s, -1, 1) == '"') $s = substr($s, 0, -1);
  		return $s;
  	}
  }
! endif;
